<template>
  <div class="evaluation-container flex container">
    <h2>Evaluation</h2>
    <div
      v-if="!accessRequest.decision_am && accessRequest.step === 1"
      class="card"
    >
      No evaluator has evaluated so far
    </div>
    <div v-if="accessRequest.decision_am != null" class="am-evaluation card">
      <div class="main_am_evaluation">
        <h3>Access Manager(s) evaluation</h3>
        <table>
          <tr>
            <td width="600px">Is the proposed research new and original?</td>
            <td>
              <b :class="accessRequest.first_question_am">{{
                accessRequest.first_question_am ?? '-'
              }}</b>
            </td>
          </tr>
          <tr>
            <td>Is the proposed research scientifically relevant?</td>
            <td>
              <b :class="accessRequest.second_question_am">{{
                accessRequest.second_question_am ?? '-'
              }}</b>
            </td>
          </tr>
          <tr>
            <td>Is the proposed research relevant in a policy context?</td>
            <td>
              <b :class="accessRequest.third_question_am">{{
                accessRequest.third_question_am ?? '-'
              }}</b>
            </td>
          </tr>
          <tr>
            <td>
              Is the proposal clear (in terms of scientifically objectives and
              requested data)?
            </td>
            <td>
              <b :class="accessRequest.forth_question_am">{{
                accessRequest.forth_question_am ?? '-'
              }}</b>
            </td>
          </tr>
          <tr>
            <td>Decision:</td>
            <td>
              <b :class="accessRequest.decision_am">{{
                accessRequest.decision_am ?? '-'
              }}</b>
            </td>
          </tr>
          <tr>
            <td>Evaluator:</td>
            <td>
              <b>{{
                accessRequest.datasets.find((dataset) => dataset.is_main === 1)
                  .am_email ?? '-'
              }}</b>
            </td>
          </tr>
          <tr>
            <td>Reasoning:</td>
            <td>{{ accessRequest.reasoning_am ?? '-' }}</td>
          </tr>
          <tr>
            <td>Evaluation Date:</td>
            {{
              new Date(
                accessRequest.datasets.find(
                  (dataset) => dataset.is_main === 1
                ).decision_date
              ).toLocaleString('en-UK', {
                dateStyle: 'medium',
                timeStyle: 'short',
              })
            }}
          </tr>
        </table>
      </div>
      <div
        v-if="accessRequest.datasets.length > 1"
        class="secondary_am_evaluation"
      >
        <h4>Secondary Datasets evaluation</h4>
        <table class="table">
          <tr>
            <th>Dataset</th>
            <th>Access Managers</th>
            <th>Decision</th>
            <th>Evaluator</th>
            <th>Evaluation date</th>
            <th>Reasoning</th>
          </tr>
          <tr
            v-for="dataset in accessRequest.datasets.filter(
              (d) => d.is_main === 0
            )"
            :key="dataset.id"
          >
            <td>{{ dataset.dataset.label }}</td>
            <td>
              <span
                v-for="email in dataset.dataset.access_managers.map(
                  (am) => am.user_email
                )"
                :key="email"
              >
                {{ email }}
                <br />
              </span>
            </td>
            <td>
              <b
                :class="
                  dataset.decision !== null ? decisions[dataset.decision] : ''
                "
              >
                <span v-if="dataset.decision !== null">
                  {{ decisions[dataset.decision] }}
                </span>
                <span v-if="dataset.decision === null">-</span>
              </b>
            </td>
            <td>
              <span v-if="dataset.am_email">{{ dataset.am_email }}</span>
              <span v-if="!dataset.am_email">-</span>
            </td>
            <td>
              {{
                dataset.decision_date
                  ? new Date(dataset.decision_date).toLocaleString('en-UK', {
                      dateStyle: 'medium',
                      timeStyle: 'short',
                    })
                  : '-'
              }}
            </td>
            <td>{{ dataset.description ?? '-' }}</td>
          </tr>
        </table>
      </div>
    </div>
    <div
      v-if="accessRequest.decision_prb != null && accessRequestYear < 2024"
      class="prb-evaluation card"
    >
      <h3>Project Review Board evaluation</h3>
      <table>
        <tr>
          <td width="600px">Is the proposed research new and original?</td>
          <td>
            <b :class="accessRequest.first_question_prb">{{
              accessRequest.first_question_prb ?? '-'
            }}</b>
          </td>
        </tr>
        <tr>
          <td>Is the proposed research scientifically relevant?</td>
          <td>
            <b :class="accessRequest.second_question_prb">{{
              accessRequest.second_question_prb ?? '-'
            }}</b>
          </td>
        </tr>
        <tr>
          <td>Is the proposed research relevant in a policy context?</td>
          <td>
            <b :class="accessRequest.third_question_prb">{{
              accessRequest.third_question_prb ?? '-'
            }}</b>
          </td>
        </tr>
        <tr>
          <td>
            Is the proposal clear (in terms of scientifically objectives and
            requested data)?
          </td>
          <td>
            <b :class="accessRequest.forth_question_prb">{{
              accessRequest.forth_question_prb ?? '-'
            }}</b>
          </td>
        </tr>
        <tr>
          <td>Decision:</td>
          <td>
            <b :class="accessRequest.decision_prb">{{
              accessRequest.decision_prb ?? '-'
            }}</b>
          </td>
        </tr>
        <tr>
          <td>Reasoning:</td>
          <td>{{ accessRequest.reasoning_prb ?? '-' }}</td>
        </tr>
      </table>
    </div>
    <div v-if="accessRequest.decision_pc != null" class="pc-evaluation card">
      <h3>Project Coordinator evaluation</h3>
      <table>
        <tr>
          <td width="600px">Decision:</td>
          <td>
            <b :class="accessRequest.decision_pc">{{
              accessRequest.decision_pc ?? '-'
            }}</b>
          </td>
        </tr>
      </table>
    </div>
  </div>
</template>
<script>
export default {
  props: {
    accessRequest: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      decisions: ['Negative', 'Positive', 'Revise'],
      accessRequestYear: null,
    };
  },
  mounted() {
    const date = new Date(this.accessRequest.created_at);
    this.accessRequestYear = date.getFullYear();
  },
};
</script>
<style scoped>
table tr td {
  vertical-align: top;
  padding: 5px;
}

.card {
  border: 1px solid lightblue;
  border-radius: 2px;
  margin-bottom: 20px;
  padding: 10px;
}

.Low,
.Negative {
  color: rgb(187, 67, 67);
}

.Medium {
  color: rgb(255, 176, 106);
}

.High,
.Positive {
  color: rgb(96, 181, 96);
}

.Revise {
}
</style>
